catch {destroy .preprocess} 
toplevel .preprocess
wm title .preprocess "Reference Levels Setting"

set preprocess "__temp_preprocess.pgm"

wm minsize .preprocess 400 200

global refLevels

set NONE     -1
set DILATE    0
set ERODE     1
set OPEN      2
set CLOSE     3
set ADDVALUE  4
set AREAOPEN  5
set AREACLOSE 6
set ASFCO     7
set ASFOC     8

set operation $NONE

frame .preprocess.options -relief groove -borderwidth 4

frame .preprocess.options.col1
frame .preprocess.options.col1.dilate
radiobutton .preprocess.options.col1.dilate.b1 -text "Dilate" -variable operation -value $DILATE
entry .preprocess.options.col1.dilate.e1 -textvariable p($DILATE) -width 5 -bg gray
pack .preprocess.options.col1.dilate.b1 .preprocess.options.col1.dilate.e1 -side left
bind .preprocess.options.col1.dilate.e1 <ButtonPress> {set operation $DILATE}
bind .preprocess.options.col1.dilate.e1 <Key-Return> {View}

frame .preprocess.options.col1.erode
radiobutton .preprocess.options.col1.erode.b1 -text "Erode" -variable operation -value $ERODE
entry .preprocess.options.col1.erode.e1 -textvariable p($ERODE) -width 5 -bg gray
pack .preprocess.options.col1.erode.b1 .preprocess.options.col1.erode.e1 -side left
bind .preprocess.options.col1.erode.e1 <ButtonPress> {set operation $ERODE}
bind .preprocess.options.col1.erode.e1 <Key-Return> {View}

pack .preprocess.options.col1.dilate .preprocess.options.col1.erode -side bottom

frame .preprocess.options.col2
frame .preprocess.options.col2.open
radiobutton .preprocess.options.col2.open.b1 -text "Open" -variable operation -value $OPEN
entry .preprocess.options.col2.open.e1 -textvariable p($OPEN) -width 5 -bg gray
pack .preprocess.options.col2.open.b1 .preprocess.options.col2.open.e1 -side left
bind .preprocess.options.col2.open.e1 <ButtonPress> {set operation $OPEN}
bind .preprocess.options.col2.open.e1 <Key-Return> {View}

frame .preprocess.options.col2.close
radiobutton .preprocess.options.col2.close.b1 -text "Close" -variable operation -value $CLOSE
entry .preprocess.options.col2.close.e1 -textvariable p($CLOSE) -width 5 -bg gray
pack .preprocess.options.col2.close.b1 .preprocess.options.col2.close.e1 -side left
bind .preprocess.options.col2.close.e1 <ButtonPress> {set operation $CLOSE}
bind .preprocess.options.col2.close.e1 <Key-Return> {View}

pack .preprocess.options.col2.open .preprocess.options.col2.close -side bottom


frame .preprocess.options.col3
frame .preprocess.options.col3.areaopen
radiobutton .preprocess.options.col3.areaopen.b1 -text "Area Open" -variable operation -value $AREAOPEN
entry .preprocess.options.col3.areaopen.e1 -textvariable p($AREAOPEN) -width 5 -bg gray
pack .preprocess.options.col3.areaopen.b1 .preprocess.options.col3.areaopen.e1 -side left
bind .preprocess.options.col3.areaopen.e1 <ButtonPress> {set operation $AREAOPEN}
bind .preprocess.options.col3.areaopen.e1 <Key-Return> {View}

frame .preprocess.options.col3.areaclose
radiobutton .preprocess.options.col3.areaclose.b1 -text "Area Close" -variable operation -value $AREACLOSE
entry .preprocess.options.col3.areaclose.e1 -textvariable p($AREACLOSE) -width 5 -bg gray
pack .preprocess.options.col3.areaclose.b1 .preprocess.options.col3.areaclose.e1 -side left
bind .preprocess.options.col3.areaclose.e1 <ButtonPress> {set operation $AREACLOSE}
bind .preprocess.options.col3.areaclose.e1 <Key-Return> {View}

pack .preprocess.options.col3.areaopen .preprocess.options.col3.areaclose -side bottom


frame .preprocess.options.col4
frame .preprocess.options.col4.asfoc
radiobutton .preprocess.options.col4.asfoc.b1 -text "ASF OC" -variable operation -value $ASFOC
entry .preprocess.options.col4.asfoc.e1 -textvariable p($ASFOC) -width 5 -bg gray
pack .preprocess.options.col4.asfoc.b1 .preprocess.options.col4.asfoc.e1 -side left
bind .preprocess.options.col4.asfoc.e1 <ButtonPress> {set operation $ASFOC}
bind .preprocess.options.col4.asfoc.e1 <Key-Return> {View}

frame .preprocess.options.col4.asfco
radiobutton .preprocess.options.col4.asfco.b1 -text "ASF CO" -variable operation -value $ASFCO
entry .preprocess.options.col4.asfco.e1 -textvariable p($ASFCO) -width 5 -bg gray
pack .preprocess.options.col4.asfco.b1 .preprocess.options.col4.asfco.e1 -side left
bind .preprocess.options.col4.asfco.e1 <ButtonPress> {set operation $ASFCO}
bind .preprocess.options.col4.asfco.e1 <Key-Return> {View}

pack .preprocess.options.col4.asfoc .preprocess.options.col4.asfco -side bottom


frame .preprocess.options.col5
frame .preprocess.options.col5.addvalue
radiobutton .preprocess.options.col5.addvalue.b1 -text "Add Value" -variable operation -value $ADDVALUE
entry .preprocess.options.col5.addvalue.e1 -textvariable p($ADDVALUE) -width 5 -bg gray
pack .preprocess.options.col5.addvalue.b1 .preprocess.options.col5.addvalue.e1 -side left
bind .preprocess.options.col5.addvalue.e1 <ButtonPress> {set operation $ADDVALUE}
bind .preprocess.options.col5.addvalue.e1 <Key-Return> {View}

frame .preprocess.options.col5.restore
button .preprocess.options.col5.restore.b1 -text "Use Input Image" -command {RestoreInputImage}
pack .preprocess.options.col5.restore.b1 -side left -fill both

pack .preprocess.options.col5.restore .preprocess.options.col5.addvalue  -side bottom -fill both


#pack all the columns together
pack .preprocess.options.col1 .preprocess.options.col2 .preprocess.options.col3 .preprocess.options.col4 .preprocess.options.col5 -side left

frame .preprocess.go
#button .f3.b1 -text "New .Tcl" -command {source filter.tcl}
button .preprocess.go.view -text "view" -command {View }
button .preprocess.go.accept -text "accept" -command {Accept}
button .preprocess.go.cancel -text "cancel" -command {Cancel}
pack .preprocess.go.view .preprocess.go.accept .preprocess.go.cancel -fill both -expand true -side left

pack .preprocess.go .preprocess.options -expand true -fill both -side bottom


proc RestoreInputImage {} {
    global original refLevels preprocess
    if {[file exists $preprocess]} {
	eval "exec cp $original $preprocess"
    }
    eval "exec cp $original $refLevels"
    DisplayRefLevelsImage $original
    .preprocess.go.cancel configure -text "close"
}

proc Accept {} {
    global refLevels preprocess useGrad gradRefLevels
    if {[file exists $preprocess]} {
	eval "exec mv $preprocess $refLevels"
	
	if {$useGrad == 1} {
	    eval "exec morph $refLevels $gradRefLevels grad"
	}
    }

    .preprocess.go.cancel configure -text "close"
}

proc Cancel {} {
    global preprocess
    if {[file exists $preprocess]} {
	eval "exec rm $preprocess"
    }
    destroy .preprocess
}


proc View {} {
    global refLevels preprocess operation p DILATE ERODE OPEN CLOSE ADDVALUE AREAOPEN AREACLOSE ASFCO ASFOC

#    puts "operation is $operation and value is $p($operation)"

    if {$p($operation) == ""} {
	puts "empty value"
    } else {
	ShowWait .preprocess 
#.preprocess.frameRefLevels
	if {$operation == $DILATE} {
#	    puts "dilate $p($DILATE)"
	    eval "exec morph $refLevels $preprocess dilate $p($operation)"
	    
	} elseif {$operation == $ERODE} {
#	    puts "erode $p($ERODE)"
	    eval "exec morph $refLevels $preprocess erode $p($operation)"

	} elseif {$operation == $OPEN} {
#	    puts "open $p($OPEN)"
	    eval "exec morph $refLevels $preprocess open $p($operation)"

	} elseif {$operation == $CLOSE} {
#	    puts "close $p($CLOSE)"
	    eval "exec morph $refLevels $preprocess close $p($operation)"

	} elseif {$operation == $ADDVALUE} {
#	    puts "addvalue $p($ADDVALUE)"
	    eval "exec morph $refLevels $preprocess add $p($operation)"

	} elseif {$operation == $AREAOPEN} {
#	    puts "areaopen $p($AREAOPEN)"
	    eval "exec morph $refLevels $preprocess areaopen $p($operation)"


	} elseif {$operation == $AREACLOSE} {
#	    puts "areaclose $p($AREACLOSE)"
	    eval "exec morph $refLevels $preprocess areaclose $p($operation)"

	} elseif {$operation == $ASFCO} {
#	    puts "asfco $p($ASFCO)"
	    eval "exec morph $refLevels $preprocess asfco $p($operation)"

	} elseif {$operation == $ASFOC} {
#	    puts "asfoc $p($ASFOC)"
	    eval "exec morph $refLevels $preprocess asfoc $p($operation)"

	}

	ShowNormal .preprocess

	DisplayRefLevelsImage $preprocess
	.preprocess.go.cancel configure -text "cancel"
    }
}


proc DisplayRefLevelsImage refLevels  {
    destroy .preprocess.frameRefLevels

    image create photo imgRefLevels -file $refLevels
    set w [image width imgRefLevels]
    set h [image height imgRefLevels]

    frame .preprocess.frameRefLevels -width 2
    canvas .preprocess.frameRefLevels.c1 -width $w -height $h
    .preprocess.frameRefLevels.c1 create image [expr $w/2] [expr $h/2] -image imgRefLevels -tag ImagemRefLevels

#    ShowNormalCursor    
#    .frame2 config -cursor left_ptr

    ShowNormal .preprocess

    pack .preprocess.frameRefLevels.c1 -side left 
    pack .preprocess.frameRefLevels -side top
}

proc ShowNormal {frame} {
    $frame config -cursor top_left_arrow
    update idletasks
}



DisplayRefLevelsImage $refLevels